/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.enterprise.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.enterprise.entity.Enterprise;
import org.springblade.enterprise.service.IEnterpriseService;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.enterprise.entity.Project;
import org.springblade.enterprise.vo.ProjectVO;
import org.springblade.enterprise.wrapper.ProjectWrapper;
import org.springblade.enterprise.service.IProjectService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-03-30
 */
@RestController
@AllArgsConstructor
@RequestMapping("/project")
@Api(value = "", tags = "接口")
public class ProjectController extends BladeController {

	private final IProjectService projectService;
	private final IOrgPositionClient orgPositionClient;
	private final IEnterpriseService enterpriseService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入project")
	public R<ProjectVO> detail(Project project) {
		Project detail = projectService.getOne(Condition.getQueryWrapper(project));
		return R.data(ProjectWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入project")
	public R<IPage<ProjectVO>> list(@RequestParam Map<String,Object> project, Query query) {
		Long enterpriseId = null;
		if(project.get("enterprise_id") != null){
			enterpriseId = Long.parseLong(String.valueOf(project.get("enterprise_id")));
			project.remove("enterprise_id");
		}
		LambdaQueryWrapper<Project> queryWrapper = new QueryWrapperUtil<Project>().getBasicQueryWrapperByMap(Project::getOrgPosition, project, new Project(), AuthUtil.getUser(), orgPositionClient);
		IPage<Project> pages = projectService.page(Condition.getPage(query), queryWrapper.eq(Project::getTenantId,AuthUtil.getUser().getTenantId()).eq(enterpriseId != null, Project::getEnterpriseId, enterpriseId));
		return R.data(ProjectWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入project")
	public R<IPage<ProjectVO>> page(ProjectVO project, Query query) {
		IPage<ProjectVO> pages = projectService.selectProjectPage(Condition.getPage(query), project);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入project")
	public R save(@Valid @RequestBody Project project) {
		return R.status(projectService.save(project));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入project")
	public R update(@Valid @RequestBody Project project) {
		return R.status(projectService.updateById(project));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入project")
	public R submit(@Valid @RequestBody Project project) {
		if (project.getEnterpriseId() != null) {
			Enterprise search = new Enterprise();
			search.setId(project.getEnterpriseId());
			Enterprise enterprise = enterpriseService.getById(search);
			Assert.notNull(enterprise, "找不到所属企业");
			project.setOrgPosition(enterprise.getOrgPosition());
			project.setTenantId(enterprise.getTenantId());
		}
		return R.status(projectService.saveOrUpdate(project));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(projectService.deleteLogic(Func.toLongList(ids)));
	}


}
